﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Forms/XeP3Master.master" AutoEventWireup="true" CodeFile="ProjectPlan.aspx.cs" Inherits="Forms_ProjectPlan" %>
<%@ MasterType virtualpath="~/Forms/XeP3Master.master" %>
<%@ Register Src="~/UserControls/ucMessageDialog.ascx" TagName="ucMessageDialog" TagPrefix="csa" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
    <title>XeP3: Momentum Methods Project Plan</title>
    <link href="../Stylesheets/Momentum.css" rel="stylesheet" type="text/css" />
    <link href="../Stylesheets/EditAction.css" rel="stylesheet" type="text/css" />
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
    <div id="wrapper">

        <igmisc:WebPanel ID="pnlOwner" runat="server" Width="99%" >
            <Header Text="Display Actions for Owner: " TextAlignment="Left">
                <ExpandedAppearance>
                    <Styles Font-Size="Small">
                        <Padding Left="10px" />
                    </Styles>
                </ExpandedAppearance>
            </Header>
        <PanelStyle BackColor="#E0F3FB" CustomRules="Background-repeat: repeat-x;">
        </PanelStyle>
        <Template>
            <table class="dataEntryTableMargin dataEntryCaptionSmaller" width="100%" style="margin-top:5px; margin-bottom:5px;">
            <tr>
            <td width="20%"><asp:Label ID="lblOwner" runat="server" Text="Select Action Owner to view:" ></asp:Label></td>
            <td width="40%"><ig:WebDropDown ID="cboActionOwner" runat="server" TabIndex="0" CssClass="dataEntryControlSmaller"
                    TextField="Name" ValueField="UserIDString" DisplayMode="DropDown" EnableCustomValues="False" EnableCustomValueSelection="False" 
                    DropDownContainerWidth="300px" DropDownContainerHeight="150px" EnableDropDownAsChild="False" AutoPostBack="True" >
                    <ClientEvents Initialize="SelectAllOnFocus" Focus="SelectAllOnFocus" /></ig:WebDropDown></td>
            <td width="40%"></td>
            </tr>   
            </table>                    

        </Template>
        </igmisc:WebPanel>

        <div style="margin-top: 5px; height:90%">
            <ig:WebDataMenu runat="server" ID="ContextMenu" IsContextMenu="true" >
                <ClientEvents ItemClick="MenuItem_Click" />
                <Items>
                    <ig:DataMenuItem Text="Add Actions" Key="AddAction" ImageUrl="~/images/ChartGanttAdd16.png" />
                    <ig:DataMenuItem Text="Add Steps" Key="AddStep" ImageUrl="~/images/ChartGanttAdd16.png" />
                    <ig:DataMenuItem Text="Add Resolution Steps" Key="AddResolutionStep" ImageUrl="~/images/ChartGanttAdd16.png" />
                    <ig:DataMenuItem Text="Insert" Key="Insert" ImageUrl="~/images/ChartGanttAdd16.png" />
                    <ig:DataMenuItem Text="Edit" Key="Edit" ImageUrl="~/images/ChartGanttEdit16.png" />
                    <ig:DataMenuItem Text="Delete" Key="Delete" ImageUrl="~/images/ChartGanttDelete16.png" />
                </Items>
            </ig:WebDataMenu>

        <ig:WebHierarchicalDataGrid ID="whgProjectPlan" runat="server" 
            Height="100%" Width="99%" AutoGenerateBands="False" 
            AutoGenerateColumns="False" DataKeyFields="ActionIDString" 
            DataMember="dsAction_DefaultView" DataSourceID="dsProjectPlan" 
            Key="dsAction_DefaultView" onrowsdeleting="whgProjectPlan_RowsDeleting" 
                oninitializerow="whgProjectPlan_InitializeRow" >
        <ClientEvents MouseDown="GridMouseDown" RowExpanding="rowExpanding" />
<GroupingSettings>
<RemoveButton AltText="Ungroup Column"></RemoveButton>
</GroupingSettings>
            <Columns>
                <ig:BoundDataField DataFieldName="ActionIDString" Hidden="True" 
                    Key="ActionIDString">
                    <Header Text="ActionIDString" />
                </ig:BoundDataField>
                <ig:BoundDataField DataFieldName="ProjectIDString" Hidden="True" 
                    Key="ProjectIDString">
                    <Header Text="ProjectIDString" />
                </ig:BoundDataField>
                <ig:BoundDataField DataFieldName="ActionNo" Key="ActionNo" 
                    Width="100px" DataType="System.Int32">
                    <Header Text="Action No" />
                </ig:BoundDataField>
                <ig:BoundDataField DataFieldName="Description" Key="Description" Width="250px">
                    <Header Text="Description" />
                </ig:BoundDataField>
                <ig:BoundDataField DataFieldName="OwnerString" Key="OwnerString" Width="150px">
                    <Header Text="Owner" />
                </ig:BoundDataField>
                <ig:BoundDataField DataFieldName="StatusDescription" Key="StatusDescription" 
                    Width="100px">
                    <Header Text="Status" />
                </ig:BoundDataField>
                <ig:BoundDataField DataFieldName="KeyAreaString" Key="KeyAreaString" 
                    Width="150px">
                    <Header Text="Key Area" />
                </ig:BoundDataField>
                <ig:BoundDataField DataFieldName="FunctionTypeString" Key="FunctionTypeString" 
                    Width="150px">
                    <Header Text="Function Type" />
                </ig:BoundDataField>
                <ig:BoundDataField DataFieldName="Comment" Key="Comment" Width="380px" >
                    <Header Text="Comment" />
                </ig:BoundDataField>
            </Columns>

<CollapseButton AltText="Collapse Row"></CollapseButton>

<ExpandButton AltText="Expand Row"></ExpandButton>

            <Bands>
                <ig:Band AutoGenerateColumns="False" DataKeyFields="StepIDString" 
                    DataMember="dsStep_DefaultView" Key="dsStep_DefaultView" >
                    <Bands>
                        <ig:Band AutoGenerateColumns="False" DataMember="dsResolutionStep_DefaultView" DataKeyFields="ResolutionIDString" 
                            Key="dsResolutionStep_DefaultView" ShowHeader="False">
                            <Columns>
                                <ig:BoundDataField DataFieldName="ResolutionIDString" Key="ResolutionIDString" Hidden="True" >
                                    <Header Text="ResolutionIDString" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="StepIDString" Hidden="True" 
                                    Key="StepIDString">
                                    <Header Text="StepIDString" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="ProjectIDString" Hidden="True" 
                                    Key="ProjectIDString">
                                    <Header Text="ProjectIDString" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="ResolutionStepNo" Key="ResolutionStepNo" 
                                    Width="75px">
                                    <Header Text="Res. No" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="Description" Key="Description" Width="250px">
                                    <Header Text="Description" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="OwnerDescription" Key="OwnerDescription" Width="150px">
                                    <Header Text="Owner" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="StatusDescription" Key="StatusDescription" 
                                    Width="100px">
                                    <Header Text="Status" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="Start" Key="Start" Width="95px" 
                                    DataType="System.DateTime" DataFormatString="{0:d}">
                                    <Header Text="Start Date" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="Due" Key="Due" Width="95px" 
                                    DataType="System.DateTime" DataFormatString="{0:d}">
                                    <Header Text="Date Due" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="Completed" Key="Completed" Width="95px" 
                                    DataType="System.DateTime" DataFormatString="{0:d}">
                                    <Header Text="Completed" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="PercentComplete" Key="PercentComplete" 
                                    Width="80px" DataType="System.Double">
                                    <Header Text="Complete %" />
                                </ig:BoundDataField>
                                <ig:BoundDataField DataFieldName="Comment" Key="Comment" Width="300px" >
                                    <Header Text="Comment" />
                                </ig:BoundDataField>
                                
                            </Columns>

<ExpandButton AltText="Expand Row"></ExpandButton>

<CollapseButton AltText="Collapse Row"></CollapseButton>

<GroupingSettings>
<RemoveButton AltText="Ungroup Column"></RemoveButton>
</GroupingSettings>
                            <Behaviors>
                                <ig:Sorting>
                                    <ColumnSettings>
                                        <ig:SortingColumnSetting ColumnKey="ResolutionStepNo" />
                                    </ColumnSettings>
                                </ig:Sorting>
                                <ig:EditingCore>
                                    <Behaviors>
                                        <ig:CellEditing>
                                            <ColumnSettings>
                                                <ig:EditingColumnSetting ColumnKey="OwnerDescription" EditorID="OwnerProvider2" />
                                                <ig:EditingColumnSetting ColumnKey="StatusDescription" ReadOnly="true"/>
                                                <ig:EditingColumnSetting ColumnKey="PercentComplete" EditorID="PercentProvider" />
                                                <ig:EditingColumnSetting ColumnKey="Completed" ReadOnly="true" />
                                                <ig:EditingColumnSetting ColumnKey="Due" ReadOnly="true"/>
                                                <ig:EditingColumnSetting ColumnKey="Start" ReadOnly="true"/>
                                                <ig:EditingColumnSetting ColumnKey="ResolutionStepNo" ReadOnly="true"/>
                                            </ColumnSettings>
                                            <EditModeActions EnableF2="False" MouseClick="Double" />
                                        </ig:CellEditing>
                                        <ig:RowDeleting />
                                    </Behaviors>
                                </ig:EditingCore>
                                <ig:Paging PageSize="20">
                                </ig:Paging>
                            </Behaviors>
                        </ig:Band>
                    </Bands>

                    <Columns>
                        <ig:BoundDataField DataFieldName="StepIDString" Hidden="True" 
                            Key="StepIDString">
                            <Header Text="StepIDString" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="ActionIDString" Hidden="True" 
                            Key="ActionIDString">
                            <Header Text="ActionIDString" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="ProjectIDString" Hidden="True" 
                            Key="ProjectIDString">
                            <Header Text="ProjectIDString" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="StepNo" Key="StepNo" Width="75px" 
                            DataType="System.Int32">
                            <Header Text="Step No" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Description" Key="Description" Width="250px">
                            <Header Text="Description" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="OwnerDescription" Key="OwnerDescription" Width="150px">
                            <Header Text="Owner" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="StatusDescription" Key="StatusDescription" 
                            Width="100px">
                            <Header Text="Status" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Start" Key="Start" Width="95px" 
                            DataType="System.DateTime" DataFormatString="{0:d}">
                            <Header Text="Start Date" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Due" Key="Due" Width="95px" 
                            DataType="System.DateTime" DataFormatString="{0:d}">
                            <Header Text="Date Due" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Completed" Key="Completed" Width="95px" 
                            DataType="System.DateTime" DataFormatString="{0:d}">
                            <Header Text="Completed" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="PercentComplete" Key="PercentComplete" 
                            Width="80px" DataType="System.Double">
                            <Header Text="Complete %" />
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Comment" Key="Comment" Width="300px" >
                            <Header Text="Comment" />
                        </ig:BoundDataField>
                    </Columns>

<ExpandButton AltText="Expand Row"></ExpandButton>

<CollapseButton AltText="Collapse Row"></CollapseButton>

<GroupingSettings>
<RemoveButton AltText="Ungroup Column"></RemoveButton>
</GroupingSettings>
                    <Behaviors>
                        <ig:Sorting>
                            <ColumnSettings>
                                <ig:SortingColumnSetting ColumnKey="StepNo" />
                            </ColumnSettings>
                        </ig:Sorting>
                        <ig:EditingCore>
                            <Behaviors>
                                <ig:CellEditing>
                                    <ColumnSettings>
                                        <ig:EditingColumnSetting ColumnKey="OwnerDescription" EditorID="OwnerProvider2" />
                                        <ig:EditingColumnSetting ColumnKey="StatusDescription" ReadOnly="true" />
                                        <ig:EditingColumnSetting ColumnKey="PercentComplete" EditorID="PercentProvider" />
                                        <ig:EditingColumnSetting ColumnKey="Completed" ReadOnly="true"/>
                                        <ig:EditingColumnSetting ColumnKey="Due" ReadOnly="true"/>
                                        <ig:EditingColumnSetting ColumnKey="Start" ReadOnly="true"/>
                                        <ig:EditingColumnSetting ColumnKey="StepNo" ReadOnly="true"/>
                                    </ColumnSettings>
                                    <EditModeActions EnableF2="False" MouseClick="Double" />
                                </ig:CellEditing>
                                <ig:RowDeleting />
                            </Behaviors>
                        </ig:EditingCore>
                        <ig:Paging PageSize="20">
                        </ig:Paging>
                    </Behaviors>
                </ig:Band>
            </Bands>
            <Behaviors>
                <ig:Activation>
                </ig:Activation>
                <ig:EditingCore EnableInheritance="True">
                    <Behaviors>
                        <ig:CellEditing>
                            <ColumnSettings>
                                <ig:EditingColumnSetting ColumnKey="OwnerString" EditorID="OwnerProvider" />
                                <ig:EditingColumnSetting ColumnKey="StatusDescription" ReadOnly="true" />
                                <ig:EditingColumnSetting ColumnKey="KeyAreaString" EditorID="KeyAreaProvider" />
                                <ig:EditingColumnSetting ColumnKey="FunctionTypeString" EditorID="FunctionTypeProvider" />
                                <ig:EditingColumnSetting ColumnKey="ActionNo" ReadOnly="true"/>
                            </ColumnSettings>
                            <EditModeActions EnableF2="False" MouseClick="Double" />
                        </ig:CellEditing>
                        <ig:RowDeleting EnableInheritance="True" />
                    </Behaviors>
                </ig:EditingCore>
                <ig:Selection CellClickAction="Row" RowSelectType="Single">
                </ig:Selection>
                <ig:Paging PageSize="20">
                </ig:Paging>
                <ig:Sorting>
                    <ColumnSettings>
                        <ig:SortingColumnSetting ColumnKey="ActionNo" />
                    </ColumnSettings>
                </ig:Sorting>
            </Behaviors>

            <EditorProviders>
                <ig:DropDownProvider ID="OwnerProvider">
                    <EditorControl ID="cboOwner" runat="server" DisplayMode="DropDown" DataSourceID="dsOwner" EnableCustomValues="False" EnableCustomValueSelection="False">

<Button AltText=""></Button>

                        <DropDownItemBinding  TextField="Name" ValueField="UserIDString"></DropDownItemBinding>
                        <ClientEvents Initialize="SelectAllOnFocus" Focus="SelectAllOnFocus" />
                    </EditorControl>
                </ig:DropDownProvider>

                <ig:DropDownProvider ID="OwnerProvider2">
                    <EditorControl ID="cboOwner2" runat="server" DisplayMode="DropDown" DataSourceID="dsOwner2" EnableCustomValues="False" EnableCustomValueSelection="False">

<Button AltText=""></Button>

                        <DropDownItemBinding  TextField="Name" ValueField="Name"></DropDownItemBinding>
                        <ClientEvents Initialize="SelectAllOnFocus" Focus="SelectAllOnFocus" />
                    </EditorControl>
                </ig:DropDownProvider>

                <ig:DropDownProvider ID="KeyAreaProvider">
                    <EditorControl ID="cboKeyArea" runat="server" DisplayMode="DropDown" DataSourceID="dsKeyArea" EnableCustomValues="False" EnableCustomValueSelection="False">

<Button AltText=""></Button>

                        <DropDownItemBinding  TextField="Description" ValueField="LookupIDString"></DropDownItemBinding>
                        <ClientEvents Initialize="SelectAllOnFocus" Focus="SelectAllOnFocus" />
                    </EditorControl>
                </ig:DropDownProvider>
                <ig:DropDownProvider ID="FunctionTypeProvider">
                    <EditorControl ID="cboFunctionType" runat="server" DisplayMode="DropDown" DataSourceID="dsFunctionType" EnableCustomValues="False" EnableCustomValueSelection="False">

<Button AltText=""></Button>

                        <DropDownItemBinding  TextField="Description" ValueField="LookupIDString"></DropDownItemBinding>
                        <ClientEvents Initialize="SelectAllOnFocus" Focus="SelectAllOnFocus" />
                    </EditorControl>
                </ig:DropDownProvider>
                <ig:PercentEditorProvider ID="PercentProvider">
                    <EditorControl runat="server" ID="txtPercent" DisplayFactor="1" 
                        HorizontalAlign="left" MaxValue="100" MinValue="0" MaxDecimalPlaces="0">
                    </EditorControl>
                </ig:PercentEditorProvider>
                <ig:DateTimeEditorProvider ID="DateTimeProvider">
                    <EditorControl runat="server" ID="txtDate" DisplayModeFormat="d">
                    </EditorControl>
                </ig:DateTimeEditorProvider>
            </EditorProviders>
        </ig:WebHierarchicalDataGrid>
        </div>
        
    <div style="width:99%;margin-top:10px;text-align:right">
        <igtxt:WebImageButton ID="txtRefresh" runat="server" 
            onclick="cmdRefresh_Click" Text="Refresh" Width="100px" Visible="false">
        </igtxt:WebImageButton>
        <igtxt:WebImageButton ID="cmdSave" runat="server"
            onclick="cmdSave_Click" Text="Save/Refresh" Width="100px">
        </igtxt:WebImageButton>
    </div>
    </div>
    <aikido:WebHierarchicalDataSource ID="dsProjectPlan" runat="server">
        <DataRelations>
            <aikido:DataRelation ChildColumns="ActionIDString" 
                ChildDataViewID="dsStep_DefaultView" ParentColumns="ActionIDString" 
                ParentDataViewID="dsAction_DefaultView" />
            <aikido:DataRelation ChildColumns="StepIDString" 
                ChildDataViewID="dsResolutionStep_DefaultView" ParentColumns="StepIDString" 
                ParentDataViewID="dsStep_DefaultView" />
        </DataRelations>
        <DataViews>
            <aikido:DataView ID="dsAction_DefaultView" DataMember="DefaultView" 
                DataSourceID="dsAction" />
            <aikido:DataView ID="dsStep_DefaultView" DataMember="DefaultView" 
                DataSourceID="dsStep" />
            <aikido:DataView ID="dsResolutionStep_DefaultView" DataMember="DefaultView" 
                DataSourceID="dsResolutionStep" />
        </DataViews>
    </aikido:WebHierarchicalDataSource>
    
    <asp:ObjectDataSource ID="dsAction" runat="server" DataObjectTypeName="XeP3.Action" TypeName="XeP3.ActionManager" 
        SelectMethod="GetActionsOwnerPlan" InsertMethod="Update" UpdateMethod="Update" DeleteMethod="Update" >
        <SelectParameters>
            <asp:ControlParameter ControlID="pnlOwner$cboActionOwner" PropertyName="SelectedValue" DefaultValue="0" Name="Owner" DbType="Int32" />
            <asp:Parameter DbType="Int32" Name="KeyArea" DefaultValue="0" />
            <asp:Parameter DbType="Int32" Name="FunctionType" DefaultValue="0" />
            <asp:Parameter DbType="String" Name="StatusList" DefaultValue="" />
        </SelectParameters>
    </asp:ObjectDataSource>

    <asp:ObjectDataSource ID="dsStep" runat="server" DataObjectTypeName="XeP3.Step" TypeName="XeP3.StepManager" 
        SelectMethod="GetAllSteps" InsertMethod="Update" UpdateMethod="Update" DeleteMethod="Update" >
    </asp:ObjectDataSource>
    
    <asp:ObjectDataSource ID="dsResolutionStep" runat="server" DataObjectTypeName="XeP3.ResolutionStep" TypeName="XeP3.ResolutionStepManager" 
        SelectMethod="GetAllSteps" InsertMethod="Update" UpdateMethod="Update" DeleteMethod="Update" >
    </asp:ObjectDataSource>

    <!-- do these via state as well once other code is working - will be faster-->    
    <asp:ObjectDataSource ID="dsOwner" runat="server" DataObjectTypeName="XeP3.User" TypeName="XeP3.UsersManager" 
        SelectMethod="GetUsersByProject" >
        <SelectParameters>
            <asp:Parameter DbType="Int32" Name="_ProjectID" DefaultValue="1" />
            <asp:Parameter DbType="Boolean" Name="IncludeBlank" DefaultValue="true" />
        </SelectParameters>
    </asp:ObjectDataSource>
    
    <asp:ObjectDataSource ID="dsOwner2" runat="server" DataObjectTypeName="XeP3.User" TypeName="XeP3.UsersManager" 
        SelectMethod="GetUsersByProject" >
        <SelectParameters>
            <asp:Parameter DbType="Int32" Name="_ProjectID" DefaultValue="1" />
            <asp:Parameter DbType="Boolean" Name="IncludeBlank" DefaultValue="true" />
        </SelectParameters>
    </asp:ObjectDataSource>
    
    <asp:ObjectDataSource ID="dsKeyArea" runat="server" DataObjectTypeName="XeP3.Lookup" TypeName="XeP3.LookupManager" 
        SelectMethod="GetLookupsByField" >
        <SelectParameters>
            <asp:Parameter DbType="String" Name="tableName" DefaultValue="tbl_Action" />
            <asp:Parameter DbType="String" Name="fieldName" DefaultValue="KeyArea" />
            <asp:Parameter DbType="Boolean" Name="IncludeBlankRow" DefaultValue="true" />
            <asp:Parameter DbType="String" Name="BlankDescription" DefaultValue=" " />
        </SelectParameters>
    </asp:ObjectDataSource>

    <asp:ObjectDataSource ID="dsFunctionType" runat="server" DataObjectTypeName="XeP3.Lookup" TypeName="XeP3.LookupManager" 
        SelectMethod="GetLookupsByField" >
        <SelectParameters>
            <asp:Parameter DbType="String" Name="tableName" DefaultValue="tbl_Action" />
            <asp:Parameter DbType="String" Name="fieldName" DefaultValue="FunctionType" />
            <asp:Parameter DbType="Boolean" Name="IncludeBlankRow" DefaultValue="true" />
            <asp:Parameter DbType="String" Name="BlankDescription" DefaultValue=" " />
        </SelectParameters>
    </asp:ObjectDataSource>

    <csa:ucMessageDialog ID="dlgMessage" runat="server"/>
    <div id="Div1" runat="server">
    <script language="javascript" type="text/javascript">
        var currentSelectedRow = null;
        var isInEditMode = false;

        function MenuItem_Click(menu, eventArgs) {
            if (currentSelectedRow == null)
                return;
            SelectionAction(eventArgs.getItem().get_key());
        }

        function SelectionAction(keyText) {

            var ver = getInternetExplorerVersion();
            var WindowParam = "_self";
            if (ver > -1) {
                if (ver <= 6.0)
                    // ie 6 need this param to be blank, otherwise it won't open a window - it just sits there stupidly...
                    WindowParam = "";
            }
          
            switch (keyText) {
                case "Delete":
                    if (currentSelectedRow == null)
                        return;

                    currentSelectedRow.get_grid().get_behaviors().get_selection().get_selectedRows().clear();

                    if (currentSelectedRow.get_grid().get_behaviors().get_selection().get_selectedRows().indexOf(currentSelectedRow) == -1)
                        currentSelectedRow.get_grid().get_behaviors().get_selection().get_selectedRows().add(currentSelectedRow);

                    // use main dialog eventually...
                    var grid = $find("<%= this.whgProjectPlan.ClientID %>");
                    if (confirm(getWarningMessage(grid))) {
                        grid.get_rows().remove(currentSelectedRow);
                    }
                    break;
                case "AddAction":
                    if (currentSelectedRow == null)
                        return;
                    window.open("../Forms/EditAction.aspx?ActionID=" + get_ActionID(currentSelectedRow) + "&ActionNo=" + get_ActionNo(currentSelectedRow) + "&Action=Add-Action", WindowParam);
                    break;
                case "AddStep":
                    // add to whatever is in current action
                    window.open("../Forms/EditAction.aspx?ActionID=" + get_ActionID(currentSelectedRow) + "&ActionNo=" + get_ActionNo(currentSelectedRow) + "&StepID=" + get_StepID(currentSelectedRow) + "&StepNo=" + get_StepNo(currentSelectedRow) + "&Action=Add-Step", WindowParam);
                    break;
                    
                case "AddResolutionStep":
                    // add to end of whatever is in current Step
                    window.open("../Forms/EditAction.aspx?ActionID=" + get_ActionID(currentSelectedRow) + "&ActionNo=" + get_ActionNo(currentSelectedRow) + "&StepID=" + get_StepID(currentSelectedRow) + "&StepNo=" + get_StepNo(currentSelectedRow) + "&ResolutionStepID=" + get_ResolutionStepID(currentSelectedRow) + "&ResolutionStepNo=" + get_ResolutionStepNo(currentSelectedRow) + "&Action=Add-ResolutionStep", WindowParam);
                    break;
                    
                case "Insert":
                    // insert *after* current row - whatever the level is
                    // auto deal with ActionNo...etc values
                    if (get_StepID(currentSelectedRow) == 0)
                        // action
                        window.open("../Forms/EditAction.aspx?ActionID=" + get_ActionID(currentSelectedRow) + "&ActionNo=" + get_ActionNo(currentSelectedRow) + "&Action=Insert-Action", WindowParam);
                    else if (get_ResolutionStepID(currentSelectedRow) == 0)
                        // Step
                        window.open("../Forms/EditAction.aspx?ActionID=" + get_ActionID(currentSelectedRow) + "&ActionNo=" + get_ActionNo(currentSelectedRow) + "&StepID=" + get_StepID(currentSelectedRow) + "&StepNo=" + get_StepNo(currentSelectedRow) + "&Action=Insert-Step", WindowParam);
                    else
                        // resolution
                        window.open("../Forms/EditAction.aspx?ActionID=" + get_ActionID(currentSelectedRow) + "&ActionNo=" + get_ActionNo(currentSelectedRow) + "&StepID=" + get_StepID(currentSelectedRow) + "&StepNo=" + get_StepNo(currentSelectedRow) + "&ResolutionStepID=" + get_ResolutionStepID(currentSelectedRow) + "&ResolutionStepNo=" + get_ResolutionStepNo(currentSelectedRow) + "&Action=Insert-ResolutionStep", WindowParam);
                    break;
                       
                case "Edit":
                    if (currentSelectedRow == null)
                        return;
                    // Page will edit the most detailed itemkey provided
                    window.open("../Forms/EditAction.aspx?ActionID=" + get_ActionID(currentSelectedRow) + "&ActionNo=" + get_ActionNo(currentSelectedRow) + "&StepID=" + get_StepID(currentSelectedRow) + "&StepNo=" + get_StepNo(currentSelectedRow) + "&ResolutionStepID=" + get_ResolutionStepID(currentSelectedRow) + "&ResolutionStepNo=" + get_ResolutionStepNo(currentSelectedRow) + "&Action=Edit", WindowParam);
                    break;
                default:
                    // do nothing - will write insert code next
                    break;
            }
        }

        function getWarningMessage(grid) {
            var message = "";
            if (grid._level == 0) {
                message = "Are you sure, you want do delete Action " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow);
            }
            else if (grid._level == 1) {
            message = "Are you sure, you want do delete Step " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow);
            }
            else {
                message = "Are you sure, you want do delete Resolution Step " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow);
            }
            return message;
        }

        function getMenuEditMessage(grid) {
            var message = "";
            if (grid._level == 0) {
                message = "Edit Action " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow);
            }
            else if (grid._level == 1) {
                message = "Edit Step " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow);
            }
            else {
                message = "Edit Resolution Step " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow);
            }
            return message;
        }

        function getMenuDeleteMessage(grid) {
            var message = "";
            if (grid._level == 0) {
                message = "Delete Action " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow);
            }
            else if (grid._level == 1) {
                message = "Delete Step " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow);
            }
            else {
                message = "Delete Resolution Step " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow);
            }
            return message;
        }

        function getCurrentRowEditBehavior() {
            return currentSelectedRow.get_grid().get_behaviors().get_editingCore().get_behaviors().get_rowEditingTemplate();
        }

        function isCurrentRowSelected() {
            if (currentSelectedRow.get_grid().get_behaviors().get_selection().get_selectedRows().indexOf(currentSelectedRow) == -1)
                return false;
            else
                return true;
        }

        function isCurrentRowInEditMode() {
            return currentSelectedRow.get_grid().get_behaviors().get_editingCore().get_behaviors().get_rowEditingTemplate().get_isInEditMode(currentSelectedRow);
        }

        function Closed() {
            isInEditMode = false;
        }

        function GridMouseDown(grid, eventArgs) {

            if (eventArgs.get_item() == null || !eventArgs.get_item().get_row) {
                return;
            }
            currentSelectedRow = eventArgs.get_item().get_row();
            
            var menu = $find("<%= this.ContextMenu.ClientID %>");
            menu.getItems().getItem(4).set_text(getMenuEditMessage(grid));
            menu.getItems().getItem(5).set_text(getMenuDeleteMessage(grid));

            if (grid._level == 0) {
                menu.getItems().getItem(3).set_text("Insert after Action " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow));
                menu.getItems().getItem(1).set_enabled(true);
                menu.getItems().getItem(2).set_enabled(false);
            }
            else if (grid._level == 1) {
                menu.getItems().getItem(3).set_text("Insert after Step " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow));
                menu.getItems().getItem(1).set_enabled(true);
                menu.getItems().getItem(2).set_enabled(true);
            }
            else {
                menu.getItems().getItem(3).set_text("Insert after Resolution Step " + get_ActionNo(currentSelectedRow) + "." + get_StepNo(currentSelectedRow) + "." + get_ResolutionStepNo(currentSelectedRow));
                menu.getItems().getItem(1).set_enabled(true);
                menu.getItems().getItem(2).set_enabled(true);
            }
               
            if (menu != null && eventArgs.get_browserEvent() != null && eventArgs.get_browserEvent().button == 2) {
                menu.showAt(null, null, eventArgs.get_browserEvent());
            }
        }

        function get_ActionNo(CurrentRow) {
            var Num
            switch (CurrentRow.get_grid()._level)
            {
                case 0:
                    Num= CurrentRow.get_cellByColumnKey('ActionNo').get_text();
                    break;
                case 1:
                    Num = CurrentRow.get_grid().get_parentRow().get_cellByColumnKey('ActionNo').get_text();
                    break;
                default:
                    // Resolution step
                    Num = CurrentRow.get_grid().get_parentRow().get_grid().get_parentRow().get_cellByColumnKey('ActionNo').get_text();
                    break;
            }
            return Num
        }
        
        function get_StepNo(CurrentRow) {
            var Num
            switch (CurrentRow.get_grid()._level)
            {
                case 0:
                    Num = "0";
                    break;
                case 1:
                    Num = CurrentRow.get_cellByColumnKey('StepNo').get_text();
                    break;
                default:
                    // Resolution step
                    Num = CurrentRow.get_grid().get_parentRow().get_cellByColumnKey('StepNo').get_text();
                    break;
            }
            return Num
        }

        function get_ResolutionStepNo(CurrentRow) {
            var Num
            switch (CurrentRow.get_grid()._level)
            {
                case 0:
                    Num = "0";
                    break;
                case 1:
                    Num = "0";
                    break;
                default:
                    // Resolution step
                    Num = CurrentRow.get_cellByColumnKey('ResolutionStepNo').get_text();
                    break;
            }
            return Num
        }

        function get_ActionID(CurrentRow) {
            // given the current row (whereever it is) work out the ActionID
            // either for the row, or its parent in the hierarchy...
            var Row;
            switch (CurrentRow.get_grid()._level)
            {
                case 0:
                    Row = CurrentRow;
                    break;
                case 1:
                    Row = CurrentRow.get_grid().get_parentRow();
                    break;
                default:
                    // Resolution step
                    Row = CurrentRow.get_grid().get_parentRow().get_grid().get_parentRow();
                    break;
            }
            return Row.get_cellByColumnKey('ActionIDString').get_text();
        }

        function get_StepID(CurrentRow) {
            // given the current row (whereever it is) work out the StepID
            // either for the row, or its parent in the hierarchy...
            // For Action rows, return 0
            var StepID;
            switch (CurrentRow.get_grid()._level) {
                case 0:
                    StepID = 0;
                    break;
                case 1:
                    StepID = CurrentRow.get_cellByColumnKey('StepIDString').get_text();
                    break;
                default:
                    // Resolution step
                    StepID = CurrentRow.get_grid().get_parentRow().get_cellByColumnKey('StepIDString').get_text();
                    break;
            }
            return StepID;
        }

        function get_ResolutionStepID(CurrentRow) {
            // Work out the ResolutionStepID
            // or return 0 for Step/action rows.
            var StepID;
            switch (CurrentRow.get_grid()._level) {
                case 0:
                    StepID = 0;
                    break;
                case 1:
                    StepID = 0;
                    break;
                default:
                    // Resolution step
                    StepID = CurrentRow.get_cellByColumnKey('ResolutionIDString').get_text();
                    break;
            }
            return StepID;
        }

        function openMessage() {
            // this is ugly - find the wildcard version
            var dialogWindow = $find('ctl00_dlgMessage_dlgMessageWindow')
            dialogWindow.show();
        }
        function closeMessage() {
            oWebDialogWindow1 = $find('ctl00_dlgMessage_dlgMessageWindow');
            oWebDialogWindow1.set_windowState($IG.DialogWindowState.Hidden);
        }

        function SelectAllOnFocus(sender, eventArgs) {
            sender._elements["Input"].select();
        }

        function refreshGrid() {
            document.getElementById("<%= cmdSave.ClientID %>").click();
            //__doPostBack('UpdatePanel1', '');
        }

        function rowExpanding(sender, args) {

            var col = args.get_row().get_rowIslands()[0].get_columns().get_columnFromKey("StepNo");

            if (col != null) {
                args.get_row().get_rowIslands()[0].get_behaviors().get_sorting().sortColumn(col, 1);
            }
        }
        
        function getInternetExplorerVersion()
        // Returns the version of Internet Explorer or a -1
        // (indicating the use of another browser).
        {
            var rv = -1; // Return value assumes failure.
            if (navigator.appName == 'Microsoft Internet Explorer') {
                var ua = navigator.userAgent;
                var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
                if (re.exec(ua) != null)
                    rv = parseFloat(RegExp.$1);
            }
            return rv;
        }
        
        function checkVersion() {
            var msg = "You're not using Internet Explorer.";
            var ver = getInternetExplorerVersion();

            if (ver > -1) {
                if (ver >= 8.0)
                    msg = "You're using a recent copy of Internet Explorer."
                else
                    msg = "You should upgrade your copy of Internet Explorer.";
            }
            alert(msg);
        }
        
        </script>
    </div>
</asp:Content>

